__kernel void dotProduct(
	const __global float *a,
	const __global float *b,
	__global float *out, 
	const unsigned int n,
	__local float *buffer)
{
	int idl = get_local_id(0);
	int stride = get_global_size(0);
	buffer[idl] = 0;
	
	for(int pos = get_global_id(0); pos < n; pos += stride){
		buffer[idl] += a[pos]*b[pos];
	}

	barrier(CLK_LOCAL_MEM_FENCE);	

	for(int s = 128; s > 0; s = s >> 1){	
		if(idl < s)	buffer[idl] += buffer[idl + s];
		barrier(CLK_LOCAL_MEM_FENCE);	
	}
	if(!idl) out[get_group_id(0)] = buffer[0];
}
