#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <cmath>
#include "../lib/orga2.h" 
//The OpenCL C++ bindings, with exceptions
#define __CL_ENABLE_EXCEPTIONS
#define WORK_GROUP_SIZE_X 16
#define WORK_GROUP_SIZE_Y 16
#define WIDTH 2048
#define HEIGHT 2048
#define KERFILE "MatrixMul.cl" //source of the kernels
#define KERFUNC "matrixMul" //name of the kernel to be used
#include <CL/cl.hpp>

using namespace std;
bool error = false;

int main(int argc, char** argv){
	unsigned int n, m, l;
	try{
		timerColNames(CPU);
		for(n = m = l = 16; n <= 2048; n *= 2, m *=2, l *=2){
			std::cout << n << "\t";
			unsigned int i, j, k, r;
			
			float *A = (float*) malloc(sizeof(float) * n * m);
			float *B = (float*) malloc(sizeof(float) * m * l);
			float *AB = (float*) malloc(sizeof(float) * n * l);
			timer(INIT);
			forn(i, 2){ //NUM_TESTS){ // lento, se hace media con 2, igual es mucho
				randomizeFloatMatrix((float*) A, n, m);
				randomizeFloatMatrix((float*) B, m, l);
				timer(TOGGLE);
				forn(r, n) forn(j, l){
					float acum = 0;
					forn(k, m) acum += ((float*) (A + r * m))[k] * ((float*) (B + k * l))[j];
					((float*)(AB + r*l))[j] = acum;
				}
				timer(TOGGLE);
				#ifdef TEST
				#endif
			}
			timer(FINISH);
		}
	} catch (cl::Error& err){
	  clErr(err);
	  return -1;
	}
}
