__kernel void reduce(
	const __global float *in, 
	__global float *out, 
	const unsigned int n,
	__local float *buffer)
{
	size_t idl = get_local_id(0);
	size_t stride = get_global_size(0);
	buffer[idl] = 0;
	
	for(size_t pos = get_global_id(0); pos < n; pos += stride){
		buffer[idl] += in[pos];
	}

	barrier(CLK_LOCAL_MEM_FENCE);	
	for(size_t s = 128; s > 0; s = s >> 1){	
		if(idl < s)	buffer[idl] += buffer[idl + s];
		barrier(CLK_LOCAL_MEM_FENCE);
	}
	if(!idl) out[get_group_id(0)] = buffer[0];
}
